<?php
if ( !defined( 'IN_CMS' ) ) {
    exit();
}

$settings = IoC::resolve( 'settings' );

IoC::resolve( 'eventmediator' )->attach( 'before_route', function( FastRoute\RouteCollector $r, $request, $response ) {
    $r->addRoute( 'GET', 'maintenance', 'plugins\\maintenance_mode\\controllers\\MaintenanceController@index' );
    return true;
});
    
IoC::resolve( 'eventmediator' )->attach( 'before_dispatch', function( $controller, $request, $response ) {
    $requestUri = $request->getParameters()->getURL( 'rt' );
    $user = IoC::resolve( 'user' );
    if ( ( !$user->hasPermission( 'maintenance' ) ) && ( !in_array( $requestUri, ['maintenance', 'login'] ) ) ) {
        $response->redirect( BASE_URL . 'maintenance', 307 );
    }
    return true;
});

$logger = IoC::resolve( 'logger' );
$logger->info( 'Plugin maintenance_mode initialized.' );
